#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_color3 DeepSkyBlue
#property indicator_color4 Red
#property indicator_color5 Yellow
#property indicator_color6 CLR_NONE
#property indicator_color7 CLR_NONE

#property indicator_width1 2
#property indicator_width2 2


   /*
       N-      
         .

      :

         LeftBars -     
         RightBars -     
         RightAsLeft -       
                             
                        ( )
         AddToLevel -    (/ )      

       http://dmffx.com
      
   */

//---- input parameters
extern   int       LeftBars      =  2;    //     
extern   int       RightBars     =  2;    //     
extern   bool      RightAsLeft   =  true; //            ( )
extern   int       AddToLevel    =  5;    //    (/ )

//---- buffers
double pick[];
double trok[];
double up1[];
double lo1[];
double c1[];
double ut1[];
double lt1[];

int len;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
      if(RightAsLeft){
          RightBars=LeftBars;
      }

   len=LeftBars+RightBars+1;
  
//---- indicators

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,pick);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);   
   SetIndexBuffer(1,trok);

   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,up1);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,lo1);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,c1);
   
   
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ut1);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,lt1);   
   
   SetIndexLabel(0,"Pick");
   SetIndexLabel(1,"Trough");
   SetIndexLabel(2,"Upper");
   SetIndexLabel(3,"Lower");   
   SetIndexLabel(4,"Central");   
   SetIndexLabel(5,"PickTime");   
   SetIndexLabel(6,"TroughTime");   
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);   
   SetIndexEmptyValue(2,0.0);   
   SetIndexEmptyValue(3,0.0);   
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);  
   SetIndexEmptyValue(6,0.0);     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=Bars-IndicatorCounted();
            for(int i=limit-1;i>=0;i--){
               int p=i+RightBars;
               pick[p]=0;
               trok[p]=0;
               up1[i]=up1[i+1];
               lo1[i]=lo1[i+1];
               ut1[i]=ut1[i+1];
               lt1[i]=lt1[i+1];  
               c1[i]=c1[i+1];
               int hb=iHighest(NULL,0,MODE_HIGH,len,i);
               int lb=iLowest(NULL,0,MODE_LOW,len,i);
                  if(hb==p){
                     pick[p]=High[p];
                     up1[i]=High[p]+Point*AddToLevel;
                     ut1[i]=Time[p];
                        if(ut1[i]!=0 && lt1[i]!=0){
                           c1[i]=(up1[i]/2+lo1[i]/2);
                        }
                        else{
                           c1[i]=0;
                        }
                  }
                  if(lb==p){
                     trok[p]=Low[p];   
                     lo1[i]=Low[p]-Point*AddToLevel;     
                     lt1[i]=Time[p];          
                     c1[i]=up1[i]/2+lo1[i]/2;
                        if(ut1[i]!=0 && lt1[i]!=0){
                           c1[i]=(up1[i]/2+lo1[i]/2);
                        }
                        else{
                           c1[i]=0;
                        }
                  }
                  
               

                  
            }

   return(0);
}

